/*
 @description: 客户端 核心功能 入口
 @date: 2015-12-14
 @author: Nero(Nero@Nero-zou.com)
 */
/* globals _AccountService*/

process.env.NODE_TLS_REJECT_UNAUTHORIZED = '0';

const V = {
    gui: require('nw.gui'),
    https: require('https'),
    http: require('http'),
    fs: require('fs'),
    path: require('path'),
    os: require('os'),
    md5: require('md5'),
    cheerio: require('cheerio'),
    fetch: require('fetch'),
    nodeRead: require('node-read'),
    needle: require('needle'),
    nodeCrypto: require('crypto'),
    utils: require('wxb-utils'),
    imageSize: require('image-size'),
    userAgent: 'Mozilla/5.0 (Windows NT 10.0; WOW64) ' +
        'AppleWebKit/537.36 (KHTML, like Gecko) Chrome/44.0.2403.125 Safari/537.36',
    he
};
window.V = V;
V.win = V.gui.Window.get();
V.clipboard = V.gui.Clipboard.get();
V.homeDir = process.env.HOME || (process.env.HOMEDRIVE + process.env.HOMEPATH);
V.materialDir = `${V.homeDir}/.wxb_muti`;

// 初始化
V.gui.App.on('open', function () {
    V.win.focus();
});
V.win.on('focus', function () {
    V.is_win_focus = true;
});
V.win.on('blur', function () {
    V.is_win_focus = false;
});

/* 创建数据存储目录，存在则忽略*/
V.fs.mkdir(V.materialDir, '0776', function (err) {
    if (err) {
        if (err.code === 'EEXIST') {
            return;
        }
    }
});

// 处理新打开窗口的行为
V.win.on('new-win-policy', function (frame, url, policy) {
    if (frame) {
        if ($(frame.contentWindow.document).find(`[href="${url}"]`).hasClass('extra-link')) {
            V.gui.Shell.openExternal(url);
            policy.ignore();
            return;
        }
    }
    policy.setNewWindowManifest({
        'title': '微小宝客户端',
        'icon': 'assest/img/icon.png',
        'position': 'center',
        'width': 1280,
        'height': 680,
      // "toolbar": true, /* 新版nwjs取消toolbar */
        'frame': true,
        'resizable': true,
        'min_width': 1028
    });
});

/* 创建数据存储目录，存在则忽略*/
V.fs.mkdir(V.materialDir, '0776', function (err) {
    if (err) {
        if (err.code === 'EEXIST') {
            return;
        }
    }
});

// 处理新打开窗口的行为
V.win.on('new-win-policy', function (frame, url, policy) {
    if (frame) {
        if ($(frame.contentWindow.document).find(`[href="${url}"]`).hasClass('extra-link')) {
            V.gui.Shell.openExternal(url);
            policy.ignore();
            return;
        }
    }
    policy.setNewWindowManifest({
        title: '微小宝客户端',
        icon: 'assest/img/icon.png',
        position: 'center',
        width: 1280,
        height: 680,
        frame: true,
        resizable: true,
        min_width: 1028
    });
});

// 禁止文件拖拽进入
window.ondragover = function (e) {
    e.preventDefault();
    return false;
};
window.ondrop = function (e) {
    e.preventDefault();
    return false;
};

document.onkeydown = V.utils.banBackSpace;


// 开启可以编辑的菜单
if (process.platform === 'darwin') {
    const _mb = new V.gui.Menu({ type: 'menubar' });
    _mb.createMacBuiltin('微小宝多平台', {
        hideEdit: false,
    });
    V.gui.Window.get().menu = _mb;
}
