(function (V) {
    const mflow = require('./server/modules/mflow');

    const mserver = new mflow();
    console.log('mserver init:', mserver);
    // 加入nwjs环境的参数
    mserver.manifest = V.gui.App.manifest;
    mserver.homeDir = V.homeDir;
    mserver.materialDir = V.materialDir;
    // 加入protected目录下的api
    const apiList = ['AccountService', 'ArticleService',
        'SyncHistoryService', 'LocalImageService', 'PlatformApi', 'WxbApi'];
    apiList.forEach(name => {
        mserver[name] = window[name];
    });
    mserver.VUtil = V.Util;
    mserver.Cookie = {
        getCookies: V.Util.getCookies,
        removeCookies: V.Util.removeCookies,
        removeCookie: V.Util.removeCookie,
        setCookie: V.Util.setCookie,
        setCookies: V.Util.setCookies
    };
    // 初始化其它配置项
    require('./server/modules/appconfig')(mserver);
    // 注入数据库
    require('./server/model')(mserver);

    // 错误日志上传
    require('./server/modules/error-log')(mserver);

    mserver.use(require('./server/modules/message-parse'));
    mserver.use(require('./server/modules/article-prepare'));
    mserver.use(require('./server/modules/weixin-ticket-update'));
    // message路由
    mserver.use(require('./server/router').routes());

    require('./server/modules/data-collection')(mserver);

    V.MServer = mserver;
    console.log('mserver ready.');
})(window.V);
