const co = require('co');
const AppConfig = require('../model/AppConfig');

module.exports = {
    appData: co.wrap(function*(ctx, next) {
        const app = ctx.app;
        let config = yield AppConfig.findOne();
        if (!config) {
            config = AppConfig.create({
                createtime: new Date()
            });
            yield config.save();
        }
        config.clientId = app.clientId;
        ctx.body = config.toJSON();
        ctx.body.manifest = app.manifest;
        yield next();
    }),

    saveConfig: co.wrap(function*(ctx, next) {
        const config = yield AppConfig.findOne();
        Object.assign(config, ctx.message.config);
        console.log('save config::', config);
        yield config.save();
        ctx.body = config.toJSON();
        yield next();
    }),

    reset: co.wrap(function*(ctx, next) {
        const config = yield AppConfig.findOne();
        Object.assign(config, {
            username: null,
            nickname: null,
            token: null,
            userId: null,
            filePath: null,
            is_verify_mobile: null,
            mobile: null,
        });
        yield config.save();
        ctx.body = config.toJSON();
        yield next();
    })
};
