const co = require('co');
const fsExtra = require('fs-extra');
const path = require('path');
const util = require('../modules/util');

module.exports = {
    addVoice: co.wrap(function*(ctx, next) {
        console.log('add voice.');
        const app = ctx.app;
        const sourceFile = ctx.message.sourceFile;
        const ext = path.extname(sourceFile);
        const targetFile = path.join(app.materialDir, Date.now() + ext);
        fsExtra.copySync(sourceFile, targetFile);
        let playLength = yield util.Media.meta(targetFile);
        console.log(playLength);
        playLength = playLength.duration * 1000;
        ctx.body = {
            sourceFile,
            targetFile,
            playLength,
            playLengthText: `${Math.floor(playLength / 60000)}:${(playLength % 60000) / 1000}`
        };
        yield next();
    })
};
