'use strict';

const Document = require('camo').Document;

class Account extends Document {
    constructor() {
        super();
        this.schema({
            account: {
                type: String,
                required: false
            },
            avatar: {
                type: String,
                required: false
            },
            cookies: {
                type: Object,
                required: false
            },
            cookiesMap: {
                type: Object,
                required: false
            },
            hasMsgcopyright: {
                type: Boolean,
                required: false
            },
            loginTime: {
                type: Date,
                required: false
            },
            order: {
                type: Number,
                required: true
            },
            password: {
                type: String,
                required: false
            },
            token: {
                type: String,
                required: false
            },
            type: {
                type: String,
                required: false
            },
            uid: {
                type: String,
                required: true
            },
            unid: {
                type: String,
                required: false
            },
            username: {
                type: String,
                required: false
            },
            createtime: {
                type: Date
            }
        });
    }
}

module.exports = Account;
