'use strict';

const co = require('co');
const Collection = require('./collection');
const AppConfig = require('../../model/AppConfig');

module.exports = function (app) {
    const { PlatformApi, WxbApi, clientId } = app;

    try {
        setTimeout(function () {
            AppConfig.findOne().then(function (res) {
                app.AccountService.getAccountList().then(function (r) {
                    const list = r.rows.map(function (val) {
                        return val.doc.data;
                    });

                    const ctn = new Collection(PlatformApi, WxbApi, clientId, res.token);
                    ctn.start(list);

                    // ctn.cleanDB();
                    // ctn.getDB();
                });
            });
        }, 60000);
    } catch (e) {
        throw new Error(e);
    }

    app.use(co.wrap(function*(ctx, next) {
        if (!ctx.match('/account/save')) {
            yield next();
            return;
        }
        const { userInfo } = ctx.message;

        try {
            const config = yield AppConfig.findOne();
            const ctn = new Collection(PlatformApi, WxbApi, clientId, config.token);
            ctn.start([userInfo]);
        } catch (e) {
            console.error(e.message);
        }
        console.warn('next::::::::::');
        yield next();
    }));
};
