'use strict';

module.exports = function (app) {
    app.use(function (ctx, next) {
        ctx.logStack = [];
        ctx.log = function (o) {
            if (typeof(o) == 'object') {
                ctx.logStack.push(Object.assign({}, o));
            } else {
                ctx.logStack.push(o);
            }
        };
        ctx.clearLog = function () {
            ctx.logStack = [];
        };
        return next();
    });

    app.on('error', function (err, ctx) {
        ctx.log(ctx.message);
        ctx.log(ctx.body);
        ctx.log(err.message || err);
        console.log('log stack---------');
        console.log(ctx.logStack);
        console.log(err);
        ctx.app.WxbApi.sendError(ctx.logStack).then(() => {
            console.log('send error success.');
        });
    });
};
