'use strict';

const router = require('./modules/mrouter')();
const ctrl = require('./controller');

router.on('/test', function (ctx, next) {
    ctx.body = 'test ok!';
    return next();
});

// 获取初始化的state
router.on('/app/initialState', [
    ctrl.config.appData
]);

// 配置数据
router.on('/config/appData', ctrl.config.appData);
router.on('/config/saveConfig', ctrl.config.saveConfig);
router.on('/config/reset', ctrl.config.reset);

// 文章同步
const sync = ctrl.sync;
router.on('/sync/oneAccount', [
    sync.syncPrepare,
    sync.reflashWeiXinTicket,
    sync.syncDownloadImages,
    sync.syncUploadImages,
    sync.syncTouTiaoCover,
    sync.syncYiDianCover,
    sync.syncOMQQCover,
    sync.syncWeiXinVoice,
    sync.syncArticle
]);

// 账号管理
router.on('/account/initState', [
    ctrl.account.initState
]);
router.on('/account/save', [
    ctrl.account.parseCookie,
    ctrl.account.parseWeixinInfo,
    ctrl.account.parseQQInfo,
    ctrl.account.parseJianShuInfo,
    ctrl.account.parseYiDianInfo,
    ctrl.account.save
]);

// 数据中心
router.on('/report/all', [ctrl.report.preCheck, ctrl.report.all]);
router.on('/report/detail', [ctrl.report.preCheck, ctrl.report.detail]);
router.on('/report/homeAll', [
    ctrl.report.preCheck,
    ctrl.report.detail,
    ctrl.report.all,
    ctrl.report.extend
]);
// 刷新某些账号报表数据(去缓存)
router.on('/report/reflashAccount', [
    ctrl.report.preCheck,
    ctrl.report.removeCache,
    ctrl.report.detail,
    ctrl.report.all,
    ctrl.report.extend
]);

// 编辑器辅助
router.on('/editor/addVoice', ctrl.editor.addVoice);

module.exports = router;
